#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

static inline int mt_colored() {
    return isatty(STDOUT_FILENO);
}

#define MT_COLORED(COLOR, MESSAGE) (mt_colored() ? COLOR MESSAGE "\033[0m" : MESSAGE)

#define MT_START                         \
    static int MT_Global_Failures__ = 0; \
    int MT_Checks__, MT_Failures__, MT_End__

#define MT_TEST_CASE(section_name)                                                                                     \
    for (MT_Checks__ = 0, MT_Failures__ = (printf(MT_COLORED("\033[1;37m", "[%s]"), (section_name)), 0), MT_End__ = 0; \
         MT_End__ != 1                                                                                                 \
             ? 1                                                                                                       \
             : ((mt_colored() ? printf("%s %i/%i passed\n\033[0m",                                                     \
                                       MT_Failures__ ? (MT_Failures__ == MT_Checks__ ? "\033[1;91m" : "\033[1;33m")    \
                                                     : "\033[1;92m",                                                   \
                                       MT_Checks__ - MT_Failures__,                                                    \
                                       MT_Checks__)                                                                    \
                              : printf(" %i/%i passed\n", MT_Checks__ - MT_Failures__, MT_Checks__)),                  \
                0);                                                                                                    \
         ++MT_End__)

#define MT_CHECK(...)                                                                      \
    do {                                                                                   \
        ++MT_Checks__;                                                                     \
        if (!(__VA_ARGS__)) {                                                              \
            printf(MT_COLORED("\033[1;91m", "  failed on \"%s:%i\""), __FILE__, __LINE__); \
            printf(MT_COLORED("\033[97m", " MT_CHECK(%s)\n"), #__VA_ARGS__);               \
            ++MT_Failures__;                                                               \
            ++MT_Global_Failures__;                                                        \
        }                                                                                  \
    } while (0)

#define MT_REQUIRE(...)                                                                \
    if (++MT_Checks__, !(__VA_ARGS__)) {                                               \
        printf(MT_COLORED("\033[1;91m", "  failed on \"%s:%i\""), __FILE__, __LINE__); \
        printf(MT_COLORED("\033[97m", " MT_REQUIRE(%s)\n"), #__VA_ARGS__);             \
        printf(MT_COLORED("\033[1;91m", "  aborted\n\n"));                             \
        ++MT_Failures__;                                                               \
        ++MT_Global_Failures__;                                                        \
        break;                                                                         \
    }

#define MT_RETURN                                                    \
    do {                                                             \
        if (MT_Global_Failures__) {                                  \
            printf(MT_COLORED("\033[1;91m", "Some tests failed\n")); \
            return EXIT_FAILURE;                                     \
        }                                                            \
        else {                                                       \
            printf(MT_COLORED("\033[1;92m", "All tests passed\n"));  \
            return EXIT_SUCCESS;                                     \
        }                                                            \
    } while (0)
