/*
 *
 *   (C) Copyright IBM Corp. 2005
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Module: plugin-ids.h
 */

#ifndef EVMS_PLUGINIDS_H_INCLUDED
#define EVMS_PLUGINIDS_H_INCLUDED 1

/*********\
* OEM IDs *
\*********/

#define EVMS_IBM_OEM_ID                 1
#define EVMS_IBM_OEM_NAME		"IBM"

#define EVMS_NOVELL_OEM_ID		2
#define EVMS_NOVELL_OEM_NAME		"Novell"

#define EVMS_ALT_LINUX_OEM_ID		3
#define EVMS_ALT_LINUX_OEM_NAME		"ALT Linux"


/*****************\
* Device Managers *
\*****************/

#define EVMS_DISK_PLUGIN_ID 			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_DEVICE_MANAGER,\
							    2)
#define EVMS_DISK_PLUGIN_SHORT_NAME		"LocalDskMgr"
#define EVMS_DISK_PLUGIN_LONG_NAME		"Local Disk Manager"

#define EVMS_ERROR_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_DEVICE_MANAGER,\
							    3)
#define EVMS_ERROR_PLUGIN_SHORT_NAME		"Error"
#define EVMS_ERROR_PLUGIN_LONG_NAME    		"Error Device Manager"

/******************\
* Segment Managers *
\******************/

#define EVMS_DOS_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	 \
							    EVMS_SEGMENT_MANAGER,\
							    1)
#define EVMS_DOS_PLUGIN_SHORT_NAME		"DosSegMgr"
#define EVMS_DOS_PLUGIN_LONG_NAME      		"DOS Segment Manager"

#define EVMS_S390_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	 \
							    EVMS_SEGMENT_MANAGER,\
							    2)
#define EVMS_S390_PLUGIN_SHORT_NAME		"S390SegMgr"
#define EVMS_S390_PLUGIN_LONG_NAME      	"S390 Segment Manager"

#define EVMS_GPT_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	 \
							    EVMS_SEGMENT_MANAGER,\
							    3)
#define EVMS_GPT_PLUGIN_SHORT_NAME		"GptSegMgr"
#define EVMS_GPT_PLUGIN_LONG_NAME      		"GPT Segment Manager"

#define EVMS_BSD_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	 \
							    EVMS_SEGMENT_MANAGER,\
							    7)
#define EVMS_BSD_PLUGIN_SHORT_NAME		"BSD"
#define EVMS_BSD_PLUGIN_LONG_NAME		"BSD Segment Manager"

#define EVMS_MAC_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	 \
							    EVMS_SEGMENT_MANAGER,\
							    8)
#define EVMS_MAC_PLUGIN_SHORT_NAME		"MAC"
#define EVMS_MAC_PLUGIN_LONG_NAME      		"MAC Segment Manager"

#define EVMS_MULTIPATH_PLUGIN_ID		SetPluginID(EVMS_IBM_OEM_ID,	 \
							    EVMS_SEGMENT_MANAGER,\
							    9)
#define EVMS_MULTIPATH_PLUGIN_SHORT_NAME	"Multipath"
#define EVMS_MULTIPATH_PLUGIN_LONG_NAME		"Multipath Segment Manager"

#define EVMS_TEMPLATE_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	 \
							    EVMS_SEGMENT_MANAGER,\
							    10)
#define EVMS_TEMPLATE_PLUGIN_SHORT_NAME		"Template"
#define EVMS_TEMPLATE_PLUGIN_LONG_NAME		"Template Segment Manager"

#define EVMS_LUKS_PLUGIN_ID			SetPluginID(EVMS_ALT_LINUX_OEM_ID,\
							    EVMS_REGION_MANAGER,  \
							    19)
#define EVMS_LUKS_PLUGIN_SHORT_NAME		"LUKS"
#define EVMS_LUKS_PLUGIN_LONG_NAME		"LUKS Manager"


/*****************\
* Region Managers *
\*****************/

#define EVMS_MD_LINEAR_PLUGIN_ID		SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_REGION_MANAGER,\
							    4)
#define EVMS_MD_LINEAR_PLUGIN_SHORT_NAME	"MDLinearRegMgr"
#define EVMS_MD_LINEAR_PLUGIN_LONG_NAME		"MD Linear Raid Region Manager"

#define EVMS_MD_RAID1_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_REGION_MANAGER,\
							    5)
#define EVMS_MD_RAID1_PLUGIN_SHORT_NAME 	"MDRaid1RegMgr"
#define EVMS_MD_RAID1_PLUGIN_LONG_NAME		"MD Raid 1 Region Manager"

#define EVMS_MD_RAID0_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_REGION_MANAGER,\
							    6)
#define EVMS_MD_RAID0_PLUGIN_SHORT_NAME		"MDRaid0RegMgr"
#define EVMS_MD_RAID0_PLUGIN_LONG_NAME		"MD RAID0 Region Manager"

#define EVMS_MD_RAID5_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_REGION_MANAGER,\
							    7)
#define EVMS_MD_RAID5_PLUGIN_SHORT_NAME		"MDRaid5RegMgr"
#define EVMS_MD_RAID5_PLUGIN_LONG_NAME		"MD RAID 4/5/6 Region Manager"

#define EVMS_MD_MULTIPATH_PLUGIN_ID		SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_REGION_MANAGER,\
							    9)
#define EVMS_MD_MULTIPATH_PLUGIN_SHORT_NAME	"MD Multipath"
#define EVMS_MD_MULTIPATH_PLUGIN_LONG_NAME	"MD Multipath Region Manager"

#define EVMS_LVM2_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_REGION_MANAGER,\
							    10)
#define EVMS_LVM2_PLUGIN_SHORT_NAME		"LVM2"
#define EVMS_LVM2_PLUGIN_LONG_NAME     		"LVM2 Region Manager"

#define EVMS_IMSM_PLUGIN_ID			SetPluginID(EVMS_ALT_LINUX_OEM_ID,	\
							    EVMS_REGION_MANAGER,\
							    11)
#define EVMS_IMSM_PLUGIN_SHORT_NAME		"IMSM"
#define EVMS_IMSM_PLUGIN_LONG_NAME     		"IMSM Region Manager"




/*******************************\
* File System Interface Modules *
\*******************************/

#define EVMS_JFS_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_FILESYSTEM_INTERFACE_MODULE,\
							    6)
#define EVMS_JFS_PLUGIN_SHORT_NAME		"JFS"
#define EVMS_JFS_PLUGIN_LONG_NAME      		"JFS File System Interface Module"

#define EVMS_EXT2_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_FILESYSTEM_INTERFACE_MODULE,\
							    7)
#define EVMS_EXT2_PLUGIN_SHORT_NAME		"Ext4"
#define EVMS_EXT2_PLUGIN_LONG_NAME     		"Ext4 File System Interface Module"

#define EVMS_REISER_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_FILESYSTEM_INTERFACE_MODULE,\
							    9)
#define EVMS_REISER_PLUGIN_SHORT_NAME		"ReiserFS"
#define EVMS_REISER_PLUGIN_LONG_NAME   		"ReiserFS File System Interface Module"

#define EVMS_SWAP_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_FILESYSTEM_INTERFACE_MODULE,\
							    10)
#define EVMS_SWAP_PLUGIN_SHORT_NAME		"SWAPFS"
#define EVMS_SWAP_PLUGIN_LONG_NAME      	"Swap File System Interface Module"

#define EVMS_NTFS_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_FILESYSTEM_INTERFACE_MODULE,\
							    13)
#define EVMS_NTFS_PLUGIN_SHORT_NAME		"NTFS"
#define EVMS_NTFS_PLUGIN_LONG_NAME     		"NTFS File System Interface Module"

#define EVMS_XFS_PLUGIN_ID			SetPluginID(EVMS_IBM_OEM_ID,	\
							    EVMS_FILESYSTEM_INTERFACE_MODULE,\
							    11)
#define EVMS_XFS_PLUGIN_SHORT_NAME		"XFS"
#define EVMS_XFS_PLUGIN_LONG_NAME       	"XFS File System Interface Module"

#define EVMS_OCFS2_PLUGIN_ID			SetPluginID(EVMS_NOVELL_OEM_ID,    \
							    EVMS_FILESYSTEM_INTERFACE_MODULE, \
							    14)
#define EVMS_OCFS2_PLUGIN_SHORT_NAME		"OCFS2"
#define EVMS_OCFS2_PLUGIN_LONG_NAME		"OCFS2 File System Interface Module"

#define EVMS_FAT_PLUGIN_ID			SetPluginID(EVMS_ALT_LINUX_OEM_ID, \
							    EVMS_FILESYSTEM_INTERFACE_MODULE, \
							    15)
#define EVMS_FAT_PLUGIN_SHORT_NAME		"FAT32"
#define EVMS_FAT_PLUGIN_LONG_NAME		"FAT32 File System Interface Module"

#define EVMS_BTRFS_PLUGIN_ID			SetPluginID(EVMS_ALT_LINUX_OEM_ID, \
							    EVMS_FILESYSTEM_INTERFACE_MODULE, \
							    17)
#define EVMS_BTRFS_PLUGIN_SHORT_NAME		"BtrFS"
#define EVMS_BTRFS_PLUGIN_LONG_NAME		"BtrFS File System Interface Module"

#define EVMS_MD_RAID10_PLUGIN_ID		SetPluginID(EVMS_ALT_LINUX_OEM_ID,	\
							    EVMS_REGION_MANAGER,\
							    18)
#define EVMS_MD_RAID10_PLUGIN_SHORT_NAME	"MDRaid10RegMgr"
#define EVMS_MD_RAID10_PLUGIN_LONG_NAME		"MD RAID 10 Region Manager"

#endif
